%1. Funciones incluidas útiles: Mapping functions, Build-in functions
%2. Creación de funciones simples: Command-line functions
%3. Bucles
%4. Creación de "funciones" propias más complejas: File functions


%
%
pwd %directorio
who %variables actuales en la sesión
whos %lo mismo con más datos
%

 x=[-5:1.5:5];
 y=x;
sqrt(x) % Raíz cuadrada de x 
abs(x) %Valor absoluto de x 
log(x) %Logaritmo neperiano de x 
log2(x) %Logaritmo en base a 2 de x 
log10(x) %Logaritmo en base a 10 de x 
exp(x) %Exponencial de x 
pow2(x) %Para cada elemento de x, calcula 2.^x 
%
%Trigonométricas y arcos (en radianes)
sin(x)
cos(x)
tan(x) 
sec(x)
csc(x)
cot(x)
%
asin(x)
acos(x) 
atan(x)
asec(x)
acsc(x)
acot(x)
atan2(x,y); %Calcula atan(x/y) (ver arg más abajo)
%
%Trigonometricas hiperbólicas y arcos
sinh(x)
cosh(x)
tanh(x)
sech(x)
csch(x); 
coth(x);
asinh(x);  
acosh(x);  
atanh(x); 
asech(x); 
acsch(x); 
acoth(x);
%
%Cosas de complejos
%
arg(x); %argumento de x en radianes como número complejo
angle(x); % igual que arg(x) 
conj(x); %Complejo conjugado de x 
real(x); %Parte real de x 
imag(x); %Parte imaginaria de x 
%
%Aritmética básica y vectorial
%gcd(x,y); %Calcula el máximo común divisor entre x e y (han de tener valores enteros)
%lcm(x,y); %Calcula el mínimo común múltiplo entre x e y 
sign(x); %Devuelve 1 para los elementos positivos, -1 para los negativos y 0 para el 0 
rem(x,y); %Resto entre la división de x e y (x en módulo y) 
%Calcula (ver abajo) x - y .* fix (x ./ y)
round(x);  %Redondeo de x al entero mas cercano 
fix(x) %Redondeo hacia el entero mas cercano a cero, quitar los decimales
ceil(x) %Redondeo al entero superior de x 
floor(x);  %Redondeo al entero inferior de x 
max(x); %Devuelve el máximo para cada columna de la matriz x o el máximo de los elementos del vector x 
min(x); %Devuelve el mínimo elemento del vector x o el mínimo elemento para cada columna de la matriz x 
sort(x); %Ordena de menor a mayor los elementos del vector x ó los elementos de cada columa de la matriz x
fliplr(x); %Devuelve x con las columnas en orden inverso (derecha-izquierda) 
flipud(x);% Devuelve x con las filas en orden inverso (arriba-abajo) 
%rot90(x,n);% Devuelve la matriz x rotada n veces en sentido antihorario. Si n se omite, asume n=1 
vec(x); %Devuelve un vector columna formado por las columnas de la matriz x. 
%
%
compan(p) %Crea una matriz cuyo polinomio cco es p "matriz compañera"
%
%
%Útiles de estadística
%
sum(x); %Devuelve la suma de los elementos del vector x o la suma de los elementos de cada columna de la matriz x 
prod(x); %Devuelve el producto de los elementos del vector  x ó el producto de los  elementos de cada columna de la matriz x 
sumsq(x); %Devuelve la suma del cuadrado de los elementos del vector x ó la suma del cuadrado de los elementos de cada columna de la matriz x 
cumsum(x); %Devuelve un vextor (o matriz) igual a x, cuyos elementos son las sumas acumulada de los elementos del vector x
cumprod(x); %Igual, pero con producto
median(x); %Calcula la mediana (valor central) del vector x ó la mediana para cada columna de la matriz x 
mean(x); %Calcula la media aritmética del vector x ó la media para cada columna de la matriz x 
mode(x);%Calcula la moda del vector x o para cada columna de la matriz x 
std(x); %Calcula la desviación típica del vector x ó la desviación estándar para cada columna de la matriz x 
randn % actua como rand pero según una Normal de media 0 y varianza 1
%
%
%
%
%Creación de funciones simples y=f(x)=x*sin(x)+1/(x^2+1)
%
function y = ejemplo1 (x) y=e.^x; endfunction
%
% y : es el valor de retorno. 
% ejemplo1 : es el nombre de la función. 
% x : es el argumento de entrada. 

ejemplo1(4)
ejemplo1(x)

%Comando feval
%
feval('ejemplo1',4) 
feval('sin',4) 
% indispensable cuando definamos funciones que contengan a su vez otras funciones 
%como argumentos, ya que para evaluar estas últimas, tendremos que usar feval apelando 
%a la cadena de caracteres que las define
%
%Otra forma es usando Functions handle 
%
%
feval(@sin,4)
feval(@ejemplo1,4)
%
%Vamos a crear una funcion handle. La idea es que puedan 
%ser utilizadas después como argumentos de otras funciones
%
f = @(x) x.^2; 
%Leeremos: "f es la función que a cada x le hace corresponder x al cuadrado"
%Puede ser evaluada
f(2)
feval(f,2)
plot(x,f(x))
%observar cómo pasa a ser el argumento de feval
%a veces ni siquiera necesitamos guardar una función handle para usarla:
%vamos a integrar el seno entre 0 y pi de 4 formas distintas
quad (@(x) sin (x), 0, pi) 
quad (@sin, 0, pi)
quad ('sin', 0, pi)
g = @(x) sin(x); 
quad (g, 0, pi)
%

%
function y = mala (x) y=e^x; endfunction
%
mala(4)
mala(x)
% 
function y = ejemplo2 (x)

aux=1./(x.^2+1); %atención a las operaciones con puntos: 1/x estaría mal

y=x.*sin(x)+aux;

endfunction

plot(x,ejemplo2(x))
%
%
% Funciones "no tan numéricas": vamos a crear una funcion que devuelve la letra del dni
%Las funciones definidas en ficheros *.m se caracterizan porque la primera línea (no comentada)
%comienza por la palabra function, seguida por los valores de retorno 
%(entre corchetes [ ] si son varios, y separados por comas, si hay más de uno), el signo 
%igual (=) y el nombre de la función, seguido de los argumentos 
%(entre paréntesis y separados por comas).
%La variables contenidas en un fichero .m son locales y no interfieren con nuestro espacio de trabajo
%
function y = nif (dni)
% 
% Esta funcion resuelve la letra correspondiente al dni introducido
%
letras = 'TRWAGMYFPDXBNJZSQVHLCKE';
n=rem(dni,23)+1;
y=letras(n);
endfunction


%creación de una función para calcular los 4 dígitos que hay 
%que añadir al número de cuenta para formar el ibán

%primero lo haremos "mal" (¿por qué?)

function  iban (numerocuenta)
% 
digito=98-rem(10^6*numerocuenta+142800,97);
if (digito<10) 
  printf("ES0%d\n",digito);
  else
  printf("ES%d\n",digito);
endif
endfunction

%obsérvese que las salidas no varían y pensar en el tamaño de la mantisa
%para la operación rem(num,mod)

iban(12345678901234567890)
iban(12395678901234567891)
iban(12345678901234567820)

%la siguiente sí funciona


function  iban (entidad,sucursal,dc,cuenta)
% 
% Esta funcion devuelve los 4 caracteres que se han de anteponer al 
% ccc español para crear el IBAN
% E=14
% S=28
% EEEE SSSS DD CCCCCCCCCC 142800
% 10^22=25 mod (97)
% 10^18=89 mod (97)
% 10^16=62 mod (97)
% 10^6=27 mod (97)
% 142800=16 mod (97)
%
%Ver seccion 14.2.4 Formatted Output 
%del manual para el formato de las salidas
cuenta=double(cuenta);
digito=98-rem(25*entidad+89*sucursal+62*dc+27*cuenta+16,97);
if (digito<10) 
  printf("ES0%d\n",digito);
  else
  printf("ES%d\n",digito);
endif
endfunction

iban(1234,5678,90,1234567890)
iban(1234,5678,90,1234567891)
iban(1234,5678,90,1234567820)

%pensar una modificación válida para el iban de cualquier cuenta UE



%Creación de una función para sumar polinomios del grado que sea

function s = polysum(p,q)
% Esta funcion suma polinomios p y q 
    lq=length(q);
    lp=length(p);
    p=[zeros(1,lq-lp),p];
    q=[zeros(1,lp-lq),q];
s=p+q;
end


%
%
%
%Bucles y comandos lógicos
%
% 
max_recursion_depth %máximo de iteraciones previstas en octave para bucles

%operadores relacionales
%< menor que 
% > mayor que 
% <= menor o igual que 
% >= mayor o igual que 
% == igual que 
% ~= distinto de 
% != distinto de
% Operadores lógicos 
% & and 
% | or 
% ~ negación 





function y = signo (x)
 if (x>0) disp("positivo")
   elseif (x<0) disp("negativo")
   elseif (x==0) disp("cero")
   else disp("esta funcion sólo actúa sobre números") % no olvidar que el último es else y no elseif
 endif %comentar diferencias con Matlab
endfunction

signo(3)
signo(x)

%¿Cómo se haría para actuar sobre vectores y/o matrices?
%ver comandos isscalar, isvector, ismatrix, etc...


%algunos comandos relacionados
any(x) % devuelve 0 ó 1: da 1 (de cada columna de x) si alguna entrada de x es distinta de cero
all(x) %devuelve 0 ó 1: da 1 (de cada columna de x) si todas las entrada de x son distinta de cero
find(x) % devuelve las "posiciones" (una vez alineado x) en que hay números no nulos, ver opciones
%los 3 admiten condiciones lógicas como argumentos
find(x==x(4))

% x<0 da un vector de 0 y 1 segun sea cada componente de x
% por lo tanto un vector será "cierto" si y solo si todas sus componentes son 1. 


%La función factorial (n) está definida, pero vamos a rehacerla de modo recursivo 
%(y con un error... ¿cual?) 
function y = factor (n) 
if (n > 0) 
y = n * factor (n-1); 
else 
y = 1; 
endif 
endfunction


%Creación de una función que resuelve SEL triangulares superiores 
%mediante el método de sustituciones regresivas
%El comando for
%for variable = expression  % típicamente i=1:1:N
%   comandos
%endfor

function [x] =sustregr(A,b)
% Esta funcion resuelve un sistema de ecuaciones lineales A x = b con  
% A una matriz triangular superior regular mediante sustitucion regresiva.
%
% Datos necesarios para llamar a la funcion:
%      A, matriz de coeficientes del SEL regular y triangular superior.
%      b, vector de terminos independientes (vector/es columna).
% La funcion devuelve como respuesta:
%      x,  solucion del SEL: A^-1 b .
%
[dim,dim]= size(A);
[nfb,ncb]=size(b);
x=zeros(dim,ncb);
for k = dim:-1:1 
  %x(k,:)= (b(k,:) - A(k,:)*x)./A(k,k); 
  x(k,:)= (b(k,:) - A(k,k+1:dim)*x(k+1:dim,:))./A(k,k); %ver la diferencia con el anterior
endfor
endfunction

%chequeo de resultados
n=6;
A=rand(n);
A=triu(A);
b=rand(n,3);
x=sustregr(A,b);
norm(A*x-b)

%Más sobre bucles
%
% switch %típica función a trozos
%switch test % se evalúa test, el resultado es un número escalar o una cadena de caracteres
%   case label  %el resultado se compara con todas las posibilidades contenidas en label
%      haz esto %esto es lo que hace
%   case label
%       haz esto
%    case label
%       haz esto
%    otherwise  %opcional, en cualquier otro caso
%        haz esto
%endswitch 



function y = trozos (x) 
   switch (x<0)
           case (1)
             y = x+1;
           case (0)
             y = 1-x;
           otherwise
             error ("");
   endswitch
endfunction

trozos(-3)
trozos(0.5)
trozos(4)
%¿qué pasa si x es un vector? Lo respondemos en la sesión de gráficas

%Más sobre bucles
%
% do - until
%do % haz
%comandos %lo que tengas que hacer
%until (condition) %hasta que la condición sea cierta, OJO, no "mientras"
%Nota, primero "hace"  y luego evalua la condición

n=1;
do 
disp(n);
n++; %típico para que algun contador evolucione hasta que se cumpla la condición
until (n>10)

%Más sobre bucles
%
% while %similar a do, pero primero evalua la condición, y en este caso 
%se ejecuta el proceso mientras que sea cierta

n=1;
while (n<=10) 
  disp(n);
    n++; 
endwhile

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Últimos apuntes
%
%Si se quiere forzar que una función termine de ejecutarse se puede utilizar la sentencia 
%return, que devuelve inmediatamente el control al terminal.
%
%Al igual que en C/C++/Java, la sentencia 
%break 
%hace que se termine la ejecución del bucle más interno de los que se estén ejecutando.
%forma parte pues de los comandos, no de las condiciones.
%se usa dentro de los bucles for y while
%La sentencia 
%continue 
%dentro de un bucle for o while, concluye automáticamente la iteración actual, 
%pasando a la siguiente, pero NO detiene el bucle, que es lo que haría el break:

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% COMENTARIO 1 (path y rutas varias)

%Si queremos ver la ubicacin exacta de una funcin  (esto es til cuando queremos ver exactamente su funcionamiento interno)
%simplemente escribiremos, por ejemplo
help rand
% no slo nos para qu sirve y cmo usar la funcin rand, sino que nos da, en la primera lnea de esta ayuda,
%la ruta del fichero que se ejecuta cuando la invocamos:
%`rand` is a function from the file /ruta_del fichero/rand.oct

% Cuando invocamos un comando de Octave, este lo busca en una serie de carpetas o directorios 
% predefinidos que constituyen el "Octave's search path". Podemos verlos con el comando siguiente:
%
path()
%
% Si nosotros queremos usar funciones .m que se encuentran en otras "librerias" o directorios creadas por nosotros, 
% hemos de aadir a este "path" la ruta de la carpeta que las contiene mediante el comando:
%
addpath("rutacarpeta")
%
% siendo "rutacarpeta" es la ruta completa de la carpeta que contiene a las funciones (desde el directorio raiz).
% Este comando NO incluye la bsqueda en subcarpetas y adems ser vlido nicamente durante la sesin actual de trabajo.
% Si queremos que esta nueva ruta de bsqueda sea permanente podemos ejecutar
%
savepath()
%
% En caso de querer eliminar una carpeta del path podemos ejecutar
%
rmpath("rutacarpeta")
savepath()
%
% Siempre es posible recuperar el path original de Octave mediante el comando
%
restoredefaultpath()
%
% Ver el captulo "Functions and scripts, Manipulating the Load Path" del manual de Octave para una 
% descripcin completa de estos y otros comandos relacionados.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% COMENTARIO 2 (funciones, nmero variable de argumentos)
%
% Si queremos crear una funci


n que, dependiendo del nmero de argumentos que reciba, acte de una u otra forma, 
% lo podemos hacer siguiendo la siguiente estructura:
%
function [val] = nombre_funcion (varargin) 
body 
endfunction  
%
% e indicar el el "body" de la función las acciones a realizar dependiendo de la 
% longitud de la variable genérica "varargin".
% Usar length(varargin) para contar el número de argumentos
% y varargin{i} para seleccionar la i-ésima variable
% Ver el captulo "Functions and scripts, Variable-lenght Argument Lists" del manual de 
% Octave para una descripción completa.
%
%Veamos un ejemplo variante de la anterior nif
%
function y = nif2 (varargin)
%
% nif2(numero) devuelve la letra del NIF asociano a numero
% nif2(numero,'letra') devuelve un mensaje según que letra sea 
%o no el NIF correcto
%
letras = 'TRWAGMYFPDXBNJZSQVHLCKE';
n=rem(varargin{1},23)+1;
letra=letras(n);
%
if (length(varargin)==1)
   y=letra;
elseif (letra==varargin{2})
   disp("NIF correcto") %
else 
   printf("NIF incorrecto, debe ser: %c\n",letra);
   %disp("NIF incorrecto, debe ser:"); disp(letra)%
endif
endfunction